import React from 'react';
import * as Input from './Input';
import timeTravel from '../enhancers/timeTravel';
import listOf from '../enhancers/listOf';

const CHANGE = 'CHANGE';

const model =
  [
    {Module: listOf(timeTravel(Input))}
  ];

const view = ({state, dispatch}) =>
  <div>
    {model.map(({Module}, index) =>
      <div key={index}>
        <Module.view
          {...state[index]}
          dispatch={action => dispatch({
            type: CHANGE,
            index,
            action
          })}
        />
      </div>
    )}
  </div>;

const update = (
  // Force all modules to adopt their initial state if
  // generator state is not set (i.e app initialisation)
  {state = model.map(({Module}) =>
    Module.update(undefined, {})
  )} = {},
  action = {}
) => {
  switch (action.type) {
  case CHANGE:
    const {index} = action;
    return {
      state: [
        ...state.slice(0, index),
        model[index]
          .Module.update(state[index], action.action),
        ...state.slice(index + 1)
      ]
    };
  default:
    return {state};
  }
};

export {view, update};
