import React from 'react';

const UPDATE_VALUE = 'UPDATE_VALUE';

const view = ({value, dispatch}) =>
  <input
    type="text"
    value={value}
    onChange={event => dispatch({
      type: UPDATE_VALUE,
      value: event.target.value
    })}
    />;

const update = ({value = ''} = {}, action = {}) => {
  switch (action.type) {
  case UPDATE_VALUE:
    return {value: action.value};
  default:
    return {value};
  }
};

export {view, update};
