import React from 'react';

const ADD = 'ADD';
const REMOVE = 'REMOVE';
const CHANGE = 'CHANGE';

const listOf = Child => ({
  view({list, dispatch}) {
    return (
      <div>
        <button onClick={() => dispatch({
          type: ADD
        })}>{ADD}</button>
        <button onClick={() => dispatch({
          type: REMOVE,
          index: list.length - 1
        })}>{REMOVE}</button>
        {list.map((entry, index) =>
          <Child.view
            key={index}
            {...entry}
            dispatch={action => dispatch({
              type: CHANGE,
              index,
              action
            })}
          />
        )}
      </div>
    );
  },

  update({list = []} = {}, action = {}) {
    switch (action.type) {
    case ADD:
      return {
        list: [
          ...list,
          Child.update(undefined, {type: '@@INIT'})
        ]
      };
    case REMOVE:
      return {
        list: [
          ...list.slice(0, action.index),
          ...list.slice(action.index + 1)
        ]
      };
    case CHANGE:
      return {
        list: [
          ...list.slice(0, action.index),
          Child.update(list[action.index], action.action),
          ...list.slice(action.index + 1)
        ]
      };
    default:
      return {list};
    }
  }
});

export default listOf;
